Qwt User's Guide: QwtSeriesData< T > Class Template Reference

Qwt User's Guide 6.3.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
QwtSeriesData< T > Class Template Referenceabstract

Abstract interface for iterating over samples. More...

`#include <qwt_series_data.h>`

Inheritance diagram for QwtSeriesData< T >:

## Public Member Functions
| QwtSeriesData ()
| Constructor.
virtual | ~QwtSeriesData ()
| Destructor.
virtual size_t | size () const =0
virtual T | sample (size_t i) const =0
T | firstSample () const
T | lastSample () const
virtual QRectF | boundingRect () const
virtual void | setRectOfInterest (const QRectF &rect)

## Protected Attributes
QRectF | cachedBoundingRect
| Can be used to cache a calculated bounding rectangle.

## Detailed Description

template<typename T>
class QwtSeriesData< T >

Abstract interface for iterating over samples.

Qwt offers several implementations of the QwtSeriesData API, but in situations, where data of an application specific format needs to be displayed, without having to copy it, it is recommended to implement an individual data access.

A subclass of QwtSeriesData<QPointF> must implement:

- size()
  Should return number of data points.
- sample()
  Should return values x and y values of the sample at specific position as QPointF object.
- boundingRect()
  Should return the bounding rectangle of the data series. It is used for autoscaling and might help certain algorithms for displaying the data. You can use qwtBoundingRect() for an implementation but often it is possible to implement a more efficient algorithm depending on the characteristics of the series. The member cachedBoundingRect is intended for caching the calculated rectangle.

Definition at line 49 of file qwt_series_data.h.

## Constructor & Destructor Documentation

## ◆ QwtSeriesData()

template<typename T >

QwtSeriesData< T >::QwtSeriesData | ( |  | ) |

Constructor.

Definition at line 130 of file qwt_series_data.h.

## ◆ ~QwtSeriesData()

template<typename T >

QwtSeriesData< T >::~QwtSeriesData | ( |  | ) |
| virtual

Destructor.

Definition at line 136 of file qwt_series_data.h.

## Member Function Documentation

## ◆ boundingRect()

template<typename T >

virtual QRectF QwtSeriesData< T >::boundingRect | ( |  | ) | const
| inlinevirtual

Calculate the bounding rect of all samples

The bounding rect is necessary for autoscaling and can be used for a couple of painting optimizations.

qwtBoundingRect(...) offers slow implementations iterating over the samples. For large sets it is recommended to implement something faster.

Returns
  Bounding rectangle

Reimplemented in QwtSyntheticPointData.

Definition at line 100 of file qwt_series_data.h.

## ◆ firstSample()

template<typename T >

T QwtSeriesData< T >::firstSample | ( |  | ) | const
| inline

Returns the first sample in the list.

Warning
  This function assumes that the list isn't empty.

Definition at line 80 of file qwt_series_data.h.

## ◆ lastSample()

template<typename T >

T QwtSeriesData< T >::lastSample | ( |  | ) | const
| inline

Returns the first sample in the list.

Warning
  This function assumes that the list isn't empty.

Definition at line 86 of file qwt_series_data.h.

## ◆ sample()

template<typename T >

virtual T QwtSeriesData< T >::sample | ( | size_t | i | ) | const
| pure virtual

Return a sample

Parameters

  i | Index

Returns
  Sample at position i

Implemented in QwtPointArrayData< T >, QwtCPointerData< T >, QwtValuePointData< T >, QwtCPointerValueData< T >, QwtSyntheticPointData, and QwtArraySeriesData< T >.

## ◆ setRectOfInterest()

template<typename T >

void QwtSeriesData< T >::setRectOfInterest | ( | const QRectF & | rect | ) |
| virtual

Set a the "rect of interest"

QwtPlotSeriesItem defines the current area of the plot canvas as "rectangle of interest" ( QwtPlotSeriesItem::updateScaleDiv() ). It can be used to implement different levels of details.

The default implementation does nothing.

Parameters

  rect | Rectangle of interest

Reimplemented in QwtSyntheticPointData.

Definition at line 141 of file qwt_series_data.h.

## ◆ size()

template<typename T >

virtual size_t QwtSeriesData< T >::size | ( |  | ) | const
| pure virtual

Returns
  Number of samples

Implemented in QwtPointArrayData< T >, QwtCPointerData< T >, QwtValuePointData< T >, QwtCPointerValueData< T >, QwtSyntheticPointData, and QwtArraySeriesData< T >.

## Member Data Documentation

## ◆ cachedBoundingRect

template<typename T >

QRectF QwtSeriesData< T >::cachedBoundingRect
| mutableprotected

Can be used to cache a calculated bounding rectangle.

Definition at line 123 of file qwt_series_data.h.